// naumann@stce.rwth-aachen.de

#include<cmath>
#include<stack>

template<typename T>
void f_a(T &x, T &x_a, const T &p, T &p_a, const T &w, T &w_a) {
  std::stack<T> tbr_T;
  T f1=sin(x); T f2=cos(x); T aux=exp(-(x-p)/w);
  tbr_T.push(x); x=1./(1.+aux);
  tbr_T.push(x); x=f1*(1-x)+f2*x;
  T y=x;
  x=tbr_T.top(); tbr_T.pop(); T f1_a=0, f2_a=0, aux_a=0;
  f2_a+=x*x_a; f1_a+=(1-x)*x_a; x_a=f2*x_a-f1*x_a;
  x=tbr_T.top(); tbr_T.pop(); aux_a+=-pow(1./(1.+aux),2)*x_a; x_a=0;
  x_a+=aux*-aux_a/w; p_a+=aux*aux_a/w; w_a+=aux*(x-p)/pow(w,2)*aux_a; 
  x_a+=-sin(x)*f2_a;
  x_a+=cos(x)*f1_a;
  x=y;
}
